Index: /branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- /branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 543)
+++ /branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 544)
@@ -3420,10 +3549,34 @@
             case WRITE_BC_DIR_READ:  // enter this state if a broadcast-inval is required
                 // the cache line must be erased in mem-cache, and written
-                // into XRAM. we read the cache and complete the buffer
+                                     // into XRAM.
                 {
                     assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
                             "MEMC ERROR in WRITE_BC_DIR_READ state: Bad DIR allocation");
 
-                    // update local buffer
+                    m_cpt_write_broadcast++;
+
+                    // write enable signal for data buffer.
+                    r_write_bc_data_we = true;
+
+                    r_write_fsm = WRITE_BC_TRT_LOCK;
+
+#if DEBUG_MEMC_WRITE
+                    if (m_debug)
+                        std::cout << "  <MEMC " << name() << " WRITE_BC_DIR_READ>"
+                                  << " Read the cache to complete local buffer" << std::endl;
+#endif
+                    break;
+                }
+                ///////////////////////
+            case WRITE_BC_TRT_LOCK:     // get TRT lock to check TRT not full
+                {
+                    assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
+                            "MEMC ERROR in WRITE_BC_TRT_LOCK state: Bad DIR allocation");
+
+                    // We read the cache and complete the buffer. As the DATA cache uses a
+                    // synchronous RAM, the read DATA request has been performed in the
+                    // WRITE_BC_DIR_READ state but the data is available in this state.
+                    if (r_write_bc_data_we.read())
+                    {
                     size_t set  = m_y[(addr_t)(r_write_address.read())];
                     size_t way  = r_write_way.read();
@@ -3437,25 +3590,24 @@
 
                         // complete only if mask is not null (for energy consumption)
-                        r_write_data[word]  = (r_write_data[word].read() & mask) |
+                            r_write_data[word] =
+                                (r_write_data[word].read()         &  mask) |
                             (m_cache_data.read(way, set, word) & ~mask);
-                    } // end for
-
-                    r_write_fsm = WRITE_BC_TRT_LOCK;
-
+                        }
 #if DEBUG_MEMC_WRITE
                     if(m_debug)
-                        std::cout << "  <MEMC " << name() << " WRITE_BC_DIR_READ>"
-                            << " Read the cache to complete local buffer" << std::endl;
-#endif
-                    break;
-                }
-                ///////////////////////
-            case WRITE_BC_TRT_LOCK:     // get TRT lock to check TRT not full
-                {
-                    assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_WRITE) and
-                            "MEMC ERROR in WRITE_BC_TRT_LOCK state: Bad DIR allocation");
-
-                    if(r_alloc_trt_fsm.read() == ALLOC_TRT_WRITE)
-                    {
+                            std::cout 
+                                << "  <MEMC "  << name()
+                                << " WRITE_BC_TRT_LOCK> Complete data buffer" << std::endl;
+#endif
+                    }
+
+                    if (r_alloc_trt_fsm.read() != ALLOC_TRT_WRITE)
+                    {
+                        // if we loop in this state, the data does not need to be
+                        // rewritten (for energy consuption)
+                        r_write_bc_data_we = false;
+                    break;
+                }
+
                         size_t wok_index = 0;
                         bool wok = not m_trt.full(wok_index);
@@ -3472,10 +3624,8 @@
 #if DEBUG_MEMC_WRITE
                         if(m_debug)
-                            std::cout << "  <MEMC " << name() << " WRITE_BC_TRT_LOCK> Check TRT"
-                                << " : wok = " << wok << " / index = " << wok_index << std::endl;
-#endif
-                        m_cpt_write_fsm_n_trt_lock++;
-                    }
-
+                        std::cout << "  <MEMC "  << name()
+                                  << " WRITE_BC_TRT_LOCK> Check TRT : wok = " << wok
+                                  << " / index = " << wok_index << std::endl;
+#endif
                     m_cpt_write_fsm_trt_lock++;
 
@@ -3568,4 +3718,10 @@
                     m_cache_directory.write(set, way, entry);
 
+                    if ((r_write_pktid.read() & 0x7) == TYPE_SC)
+                    {
+                        m_llsc_table.sc(r_write_address.read(),
+                                        r_write_sc_key.read());
+                    }
+
 #if DEBUG_MEMC_WRITE
                     if(m_debug)
@@ -3611,5 +3767,4 @@
                     {
                         r_write_to_ixr_cmd_req     = true;
-                        r_write_to_ixr_cmd_put     = true;
                         r_write_to_ixr_cmd_index   = r_write_trt_index.read();
                         r_write_fsm = WRITE_IDLE;
@@ -3765,5 +3920,4 @@
                         r_ixr_cmd_word    = 0;
                         r_ixr_cmd_fsm     = IXR_CMD_READ_SEND;
-                        for( size_t i=0 ; i<m_words ; i++ ) r_ixr_cmd_wdata[i] = entry.wdata[i];
 
 #if DEBUG_MEMC_IXR_CMD
@@ -3787,5 +3941,10 @@
                         r_ixr_cmd_word    = 0;
                         r_ixr_cmd_fsm     = IXR_CMD_WRITE_SEND;
+
+                        // Read data from TRT if PUT transaction
+                        if (not entry.xram_read)
+                        {
                         for( size_t i=0 ; i<m_words ; i++ ) r_ixr_cmd_wdata[i] = entry.wdata[i];
+                        }
 
 #if DEBUG_MEMC_IXR_CMD
@@ -3809,5 +3968,10 @@
                         r_ixr_cmd_word    = 0;
                         r_ixr_cmd_fsm     = IXR_CMD_CAS_SEND;
+
+                        // Read data from TRT if PUT transaction
+                        if (not entry.xram_read)
+                        {
                         for( size_t i=0 ; i<m_words ; i++ ) r_ixr_cmd_wdata[i] = entry.wdata[i];
+                        }
 
 #if DEBUG_MEMC_IXR_CMD
@@ -3909,5 +4073,5 @@
                     if(p_vci_ixr.cmdack)
                     {
-                        if(r_write_to_ixr_cmd_put.read())   // PUT
+                        if (not r_ixr_cmd_get.read())   // PUT
                         {
                             if(r_ixr_cmd_word.read() == (m_words - 2))
@@ -3946,5 +4110,5 @@
                     if(p_vci_ixr.cmdack)
                     {
-                        if(r_cas_to_ixr_cmd_put.read()) // PUT
+                        if (not r_ixr_cmd_get.read()) // PUT
                         {
                             if(r_ixr_cmd_word.read() == (m_words - 2))
@@ -4291,5 +4455,5 @@
                     r_xram_rsp_victim_way       = way;
                     r_xram_rsp_victim_set       = set;
-                    r_xram_rsp_victim_nline     = victim.tag*m_sets + set;
+                    r_xram_rsp_victim_nline     = (addr_t)victim.tag*m_sets + set;
                     r_xram_rsp_victim_is_cnt    = victim.is_cnt;
                     r_xram_rsp_victim_inval     = inval ;
@@ -4808,6 +4972,4 @@
         ////////////////////////////////////////////////////////////////////////////////////
 
-        //std::cout << std::endl << "cleanup_fsm" << std::endl;
-
         switch(r_cleanup_fsm.read())
         {
@@ -4842,5 +5004,13 @@
                             "MEMC ERROR in CLEANUP_IDLE state : illegal SRCID value");
 
-                    m_cpt_cleanup++;
+                    // <Activity Counters>
+                    if (is_local_req(srcid)) {
+                        m_cpt_cleanup_local++;
+                    }
+                    else {
+                        m_cpt_cleanup_remote++;
+                        m_cpt_cleanup_cost += req_distance(srcid);
+                    }
+                    // </Activity Counters>
                     cc_receive_to_cleanup_fifo_get = true;
                     r_cleanup_fsm                  = CLEANUP_GET_NLINE;
@@ -5589,5 +5759,4 @@
                         if(m_cmd_cas_eop_fifo.read())
                         {
-                            m_cpt_cas++;
                             r_cas_fsm = CAS_DIR_REQ;
                         }
@@ -6135,5 +6304,4 @@
                     {
                         r_cas_to_ixr_cmd_req     = true;
-                        r_cas_to_ixr_cmd_put     = true;
                         r_cas_to_ixr_cmd_index   = r_cas_trt_index.read();
                         r_cas_fsm                = CAS_IDLE;
@@ -6272,5 +6440,4 @@
                     {
                         r_cas_to_ixr_cmd_req        = true;
-                        r_cas_to_ixr_cmd_put        = false;
                         r_cas_to_ixr_cmd_index      = r_cas_trt_index.read();
                         r_cas_fsm                   = CAS_WAIT;
@@ -6328,5 +6495,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_XRAM_RSP_INVAL_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6334,5 +6500,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_XRAM_RSP_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6342,5 +6507,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CAS_UPDT_HEADER;
-                        m_cpt_update++;
                         break;
                     }
@@ -6348,5 +6512,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CAS_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6356,5 +6519,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_WRITE_UPDT_HEADER;
-                        m_cpt_update++;
                         break;
                     }
@@ -6362,5 +6524,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_WRITE_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6369,5 +6530,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CONFIG_INVAL_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6375,5 +6535,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CONFIG_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6387,5 +6546,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CONFIG_INVAL_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6393,5 +6551,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CONFIG_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6401,5 +6558,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_XRAM_RSP_INVAL_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6407,5 +6563,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_XRAM_RSP_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6415,5 +6570,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CAS_UPDT_HEADER;
-                        m_cpt_update++;
                         break;
                     }
@@ -6421,5 +6575,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CAS_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6429,5 +6582,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_WRITE_UPDT_HEADER;
-                        m_cpt_update++;
                         break;
                     }
@@ -6435,5 +6587,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_WRITE_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6448,5 +6599,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CAS_UPDT_HEADER;
-                        m_cpt_update++;
                         break;
                     }
@@ -6454,5 +6604,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CAS_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6462,5 +6611,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_WRITE_UPDT_HEADER;
-                        m_cpt_update++;
                         break;
                     }
@@ -6469,5 +6617,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_WRITE_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6476,5 +6623,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CONFIG_INVAL_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6482,5 +6628,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CONFIG_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6490,5 +6635,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_XRAM_RSP_INVAL_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6496,5 +6640,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_XRAM_RSP_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6508,5 +6651,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_WRITE_UPDT_HEADER;
-                        m_cpt_update++;
                         break;
                     }
@@ -6514,5 +6656,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_WRITE_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6521,5 +6662,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CONFIG_INVAL_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6527,5 +6667,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CONFIG_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6534,5 +6673,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_XRAM_RSP_INVAL_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6540,5 +6678,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_XRAM_RSP_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6547,5 +6684,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CAS_UPDT_HEADER;
-                        m_cpt_update++;
                         break;
                     }
@@ -6553,5 +6689,4 @@
                     {
                         r_cc_send_fsm = CC_SEND_CAS_BRDCAST_HEADER;
-                        m_cpt_inval++;
                         break;
                     }
@@ -6564,8 +6699,22 @@
                     {
                         if(not p_dspin_m2p.read) break;
+                        // <Activity Counters>
+                        if (is_local_req(m_config_to_cc_send_srcid_fifo.read()))
+                        {
+                            m_cpt_m_inval_local++;
+                        }
+                        else
+                        {
+                            m_cpt_m_inval_remote++;
+                            m_cpt_m_inval_cost += req_distance(m_config_to_cc_send_srcid_fifo.read());
+                        }
+                        // </Activity Counters>
                         r_cc_send_fsm = CC_SEND_CONFIG_INVAL_NLINE;
                         break;
                     }
                     if(r_config_to_cc_send_multi_req.read()) r_config_to_cc_send_multi_req = false;
+                    // <Activity Counters>
+                    m_cpt_m_inval++;
+                    // </Activity Counters>
                     r_cc_send_fsm = CC_SEND_CONFIG_IDLE;
                     break;
@@ -6575,5 +6724,4 @@
                 {
                     if(not p_dspin_m2p.read) break;
-                    m_cpt_inval_mult++;
                     config_to_cc_send_fifo_get = true;
                     r_cc_send_fsm = CC_SEND_CONFIG_INVAL_HEADER;
@@ -6598,5 +6746,7 @@
                 {
                     if(not p_dspin_m2p.read) break;
-                    m_cpt_inval_brdcast++;
+                    // <Activity Counters>
+                    m_cpt_br_inval++;
+                    // </Activity Counters>
                     r_config_to_cc_send_brdcast_req = false;
                     r_cc_send_fsm = CC_SEND_CONFIG_IDLE;
@@ -6616,8 +6766,22 @@
                     {
                         if(not p_dspin_m2p.read) break;
+                        // <Activity Counters>
+                        if (is_local_req(m_xram_rsp_to_cc_send_srcid_fifo.read()))
+                        {
+                            m_cpt_m_inval_local++;
+                        }
+                        else
+                        {
+                            m_cpt_m_inval_remote++;
+                            m_cpt_m_inval_cost += req_distance(m_xram_rsp_to_cc_send_srcid_fifo.read());
+                        }
+                        // </Activity Counters>
                         r_cc_send_fsm = CC_SEND_XRAM_RSP_INVAL_NLINE;
                         break;
                     }
                     if(r_xram_rsp_to_cc_send_multi_req.read()) r_xram_rsp_to_cc_send_multi_req = false;
+                    // <Activity Counters>
+                    m_cpt_m_inval++;
+                    // </Activity Counters>
                     r_cc_send_fsm = CC_SEND_XRAM_RSP_IDLE;
                     break;
@@ -6627,5 +6791,4 @@
                 {
                     if(not p_dspin_m2p.read) break;
-                    m_cpt_inval_mult++;
                     xram_rsp_to_cc_send_fifo_get = true;
                     r_cc_send_fsm = CC_SEND_XRAM_RSP_INVAL_HEADER;
@@ -6650,5 +6813,7 @@
                 {
                     if(not p_dspin_m2p.read) break;
-                    m_cpt_inval_brdcast++;
+                    // <Activity Counters>
+                    m_cpt_br_inval++;
+                    // </Activity Counters>
                     r_xram_rsp_to_cc_send_brdcast_req = false;
                     r_cc_send_fsm = CC_SEND_XRAM_RSP_IDLE;
@@ -6674,5 +6839,7 @@
                     if(not p_dspin_m2p.read) break;
 
-                    m_cpt_inval_brdcast++;
+                    // <Activity Counters>
+                    m_cpt_br_inval++;
+                    // </Activity Counters>
 
                     r_write_to_cc_send_brdcast_req = false;
@@ -6693,4 +6860,15 @@
                     {
                         if(not p_dspin_m2p.read) break;
+                        // <Activity Counters>
+                        if (is_local_req(m_write_to_cc_send_srcid_fifo.read()))
+                        {
+                            m_cpt_update_local++;
+                        }
+                        else
+                        {
+                            m_cpt_update_remote++;
+                            m_cpt_update_cost += req_distance(m_write_to_cc_send_srcid_fifo.read());
+                        }
+                        // </Activity Counters>
 
                         r_cc_send_fsm = CC_SEND_WRITE_UPDT_NLINE;
@@ -6703,4 +6881,7 @@
                     }
 
+                    // <Activity Counters>
+                    m_cpt_update++;
+                    // </Activity Counters>
                     r_cc_send_fsm = CC_SEND_WRITE_IDLE;
                     break;
@@ -6710,5 +6891,4 @@
                 {
                     if(not p_dspin_m2p.read) break;
-                    m_cpt_update_mult++;
 
                     r_cc_send_cpt = 0;
@@ -6727,5 +6907,5 @@
                 {
                     if(not p_dspin_m2p.read) break;
-                    if(r_cc_send_cpt.read() == (r_write_to_cc_send_count.read()-1))
+                    if (r_cc_send_cpt.read() == r_write_to_cc_send_count.read())
                     {
                         write_to_cc_send_fifo_get = true;
@@ -6748,5 +6928,7 @@
                 {
                     if(not p_dspin_m2p.read) break;
-                    m_cpt_inval_brdcast++;
+                    // <Activity Counters>
+                    m_cpt_br_inval++;
+                    // </Activity Counters>
 
                     r_cas_to_cc_send_brdcast_req = false;
@@ -6767,5 +6949,15 @@
                     {
                         if(not p_dspin_m2p.read) break;
-
+                        // <Activity Counters>
+                        if (is_local_req(m_cas_to_cc_send_srcid_fifo.read()))
+                        {
+                            m_cpt_update_local++;
+                        }
+                        else
+                        {
+                            m_cpt_update_remote++;
+                            m_cpt_update_cost += req_distance(m_cas_to_cc_send_srcid_fifo.read());
+                        }
+                        // </Activity Counters>
                         r_cc_send_fsm = CC_SEND_CAS_UPDT_NLINE;
                         break;
@@ -6778,4 +6970,7 @@
                     }
 
+                    // <Activity Counters>
+                    m_cpt_update++;
+                    // </Activity Counters>
                     r_cc_send_fsm = CC_SEND_CAS_IDLE;
                     break;
@@ -6785,7 +6980,4 @@
                 {
                     if(not p_dspin_m2p.read) break;
-
-                    m_cpt_update_mult++;
-
                     r_cc_send_cpt = 0;
                     r_cc_send_fsm = CC_SEND_CAS_UPDT_DATA;
@@ -7359,6 +7551,5 @@
                 /////////////////////////
             case ALLOC_UPT_MULTI_ACK:     // allocated to MULTI_ACK FSM
-                if ((r_multi_ack_fsm.read() != MULTI_ACK_UPT_LOCK ) and
-                        (r_multi_ack_fsm.read() != MULTI_ACK_UPT_CLEAR))
+                if (r_multi_ack_fsm.read() != MULTI_ACK_UPT_LOCK)
                 {
                     if (r_write_fsm.read() == WRITE_UPT_LOCK)
@@ -7814,5 +8005,5 @@
                         r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
 
-                    if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
+                    else if ((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
                             (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
                         r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
@@ -8201,5 +8392,5 @@
                         r_alloc_heap_fsm = ALLOC_HEAP_CLEANUP;
 
-                    if(r_xram_rsp_fsm.read() == XRAM_RSP_HEAP_REQ)
+                    else if (r_xram_rsp_fsm.read() == XRAM_RSP_HEAP_REQ)
                         r_alloc_heap_fsm = ALLOC_HEAP_XRAM_RSP;
                     else
@@ -8353,4 +8544,25 @@
         /////////////////////////////
     {
+#if MONITOR_MEMCACHE_FSM == 1
+        p_read_fsm.write        (r_read_fsm.read()       );
+        p_write_fsm.write       (r_write_fsm.read()      );
+        p_xram_rsp_fsm.write    (r_xram_rsp_fsm.read()   );
+        p_cas_fsm.write         (r_cas_fsm.read()        );
+        p_cleanup_fsm.write     (r_cleanup_fsm.read()    );
+        p_config_fsm.write      (r_config_fsm.read()     );
+        p_alloc_heap_fsm.write  (r_alloc_heap_fsm.read() );
+        p_alloc_dir_fsm.write   (r_alloc_dir_fsm.read()  );
+        p_alloc_trt_fsm.write   (r_alloc_trt_fsm.read()  );
+        p_alloc_upt_fsm.write   (r_alloc_upt_fsm.read()  );
+        p_alloc_ivt_fsm.write   (r_alloc_ivt_fsm.read()  );
+        p_tgt_cmd_fsm.write     (r_tgt_cmd_fsm.read()    );
+        p_tgt_rsp_fsm.write     (r_tgt_rsp_fsm.read()    );
+        p_ixr_cmd_fsm.write     (r_ixr_cmd_fsm.read()    );
+        p_ixr_rsp_fsm.write     (r_ixr_rsp_fsm.read()    );
+        p_cc_send_fsm.write     (r_cc_send_fsm.read()    );
+        p_cc_receive_fsm.write  (r_cc_receive_fsm.read() );
+        p_multi_ack_fsm.write   (r_multi_ack_fsm.read()  );
+#endif
+
         ////////////////////////////////////////////////////////////
         // Command signals on the p_vci_ixr port
@@ -8898,5 +9110,5 @@
 
                     p_dspin_m2p.write = true;
-                    p_dspin_m2p.eop   = (r_cc_send_cpt.read() == (r_write_to_cc_send_count.read()-1));
+                    p_dspin_m2p.eop   = (r_cc_send_cpt.read() == r_write_to_cc_send_count.read());
                     p_dspin_m2p.data  = flit;
 
@@ -9039,5 +9251,5 @@
             DspinDhccpParam::dspin_set(
                     flit,
-                    r_cleanup_nline.read() & 0xFFFF,
+                    r_cleanup_nline.read(),
                     DspinDhccpParam::CLACK_SET);
 
@@ -9093,6 +9305,6 @@
 
 // Local Variables:
-// tab-width: 2
-// c-basic-offset: 2
+// tab-width: 4
+// c-basic-offset: 4
 // c-file-offsets:((innamespace . 0)(inline-open . 0))
 // indent-tabs-mode: nil
